/*
  This file is under Public Domain.
*/

#include <windows.h>
#include <nscore.h>
#include "ministring.h"

miniMBString::miniMBString(const PRUnichar* c) : m_string(0) {
	static const DWORD flags = WC_COMPOSITECHECK;
	static const UINT cp = CP_ACP;
	if (c) {
		int length = WideCharToMultiByte(cp, flags, c, -1, NULL, 0, NULL, NULL);
		if (length > 0) {
			m_string = new char[length];
			if (m_string) {
				m_string[0] = '\0';
				WideCharToMultiByte(cp, flags, c, -1, m_string, length, NULL, NULL);
			}
		}
	}
}

miniWString::miniWString(const char* c) : m_string(0) {
	static const UINT cp = CP_ACP;
	static const DWORD flags = MB_PRECOMPOSED;
	if (c) {
		int length = MultiByteToWideChar(cp, flags, c, -1, NULL, 0);
		if (length > 0) {
			m_string = new WCHAR[length];
			if (m_string) {
				m_string[0] = '\0';
				MultiByteToWideChar(cp, flags, c, -1, m_string, length);
			}
		}
	}
}
